package io.zipcoder;

import java.util.ArrayList;
import java.util.Arrays;

public class StringsAndThings {

    /**
     * Given a string, count the number of words ending in 'y' or 'z' -- so the 'y' in "heavy" and the 'z' in "fez" count,
     * but not the 'y' in "yellow" (not case sensitive). We'll say that a y or z is at the end of a word if there is not an alphabetic
     * letter immediately following it. (Note: Character.isLetter(char) tests if a char is an alphabetic letter.)
     * example : countYZ("fez day"); // Should return 2
     *           countYZ("day fez"); // Should return 2
     *           countYZ("day fyyyz"); // Should return 2
     */
    public Integer countYZ(String input){

        String[] str = input.split(" ");

        Integer counter = 0;

        for(int i = 0; i < str.length; i++) {

            String value = String.valueOf((str[i].charAt(str[i].length() - 1)));

            if(value.equals("y") || value.equals("z")){
                counter = counter + 1;
            }
        }
        return counter;
    }

    /**
     * Given two strings, base and remove, return a version of the base string where all instances of the remove string have
     * been removed (not case sensitive). You may assume that the remove string is length 1 or more.
     * Remove only non-overlapping instances, so with "xxx" removing "xx" leaves "x".
     *
     * example : withoutString("Hello there", "llo") // Should return "He there"
     *           withoutString("Hello there", "e") //  Should return "Hllo thr"
     *           withoutString("Hello there", "x") // Should return "Hello there"
     */
    public String withoutString(String base, String remove){

        //First try
//        boolean checkContain = (base.contains(remove));
////
////        if(checkContain = true){
////            base = base.replace(remove,"");
////        }



        //Second try
//        base = base.replace(remove, "");



        //Third try
        return base.replace(remove, "");
    }

    /**
     * Given a string, return true if the number of appearances of "is" anywhere in the string is equal
     * to the number of appearances of "not" anywhere in the string (case sensitive)
     *
     * example : equalIsNot("This is not")  // Should return false
     *           equalIsNot("This is notnot") // Should return true
     *           equalIsNot("noisxxnotyynotxisi") // Should return true
     */
    public Boolean equalIsNot(String input){

        //this is breaking down the string into string array character by character
        String[] array = input.split("(?!^)");

        ArrayList<String> newArray = new ArrayList<String>(Arrays.asList(array));

        int isCounter = 0;
        int notCounter = 0;

        //count "is"
        for(int i = 0; i < input.length()-1; i++){
            if (array[i].equals("i") && array[i + 1].equals("s")){
                isCounter = isCounter + 1;
                    if(array[i+1].equals(null)){
                        break;
                }
            }
        }

        //count "not"
        for(int j = 0; j < input.length()-2; j++) {
            if (array[j].equals("n") && array[j + 1].equals("o") && array[j + 2].equals("t")) {
                notCounter = notCounter + 1;
                    if(array[j+1].equals(null)){
                        break;
                }
            }
        }

        return isCounter == notCounter;
    }

    /**
     * We'll say that a lowercase 'g' in a string is "happy" if there is another 'g' immediately to its left or right.
     * Return true if all the g's in the given string are happy.
     * example : gHappy("xxggxx") // Should return  true
     *           gHappy("xxgxx") // Should return  false
     *           gHappy("xxggyygxx") // Should return  false
     */
    public Boolean gIsHappy(String input){


        //this is breaking down the string into string array character by character
        String[] array = input.split("(?!^)");

        ArrayList<String> newArray = new ArrayList<String>(Arrays.asList(array));

        boolean returnValue = true;

        for(int i = 0; i < array.length; i++){
            if(array[i].equals("g") && (array[i - 1].equals("g") || array[i + 1].equals("g"))){
                returnValue = true;
            } else if(array[i].equals("g") && (!array[i - 1].equals("g") || !array[i + 1].equals("g"))){
                returnValue = false;
            }
        }

        return returnValue;
    }

    /**
     * We'll say that a "triple" in a string is a char appearing three times in a row.
     * Return the number of triples in the given string. The triples may overlap.
     * example :  countTriple("abcXXXabc") // Should return 1
     *            countTriple("xxxabyyyycd") // Should return 3
     *            countTriple("a") // Should return 0
     */
    public Integer countTriple(String input){

        //this is breaking down the string into string array character by character
        String[] array = input.split("(?!^)");

        ArrayList<String> newArray = new ArrayList<String>(Arrays.asList(array));

        int counter = 0;

        for(int i = 0; i < array.length-2; i++){
         if(array[i].equals(array[i+1]) && array[i].equals(array[i+2])){
             counter = counter + 1;
         }
        }

        return counter;
    }
}
